#ifndef lint
static char sccsid_tnregh[] = "@(#)if_tnreg.h	1.4 90/01/25-17:09:06 FAU from jpo 1.6";
#endif

/*
 * Copyright (c) 1988, Julian Onions. 
 *
 * This source may be freely distributed, however I would be interested
 * in any changes that are made.
 *
 * Modified 1990, Toerless Eckert.
 *
 * Modified 1995, IDE Kazumi <kazu@jl1kuf.jouban.prug.or.jp>
 */

/*
 * $Log:	if_tnreg.h,v $
 * Revision 1.6  88/07/11  08:28:48  jpo
 * Some tidying up
 * 
 * Revision 1.5  87/11/04  14:14:29  jpo
 * Update a few flags etc.
 * 
 * Revision 1.4  87/10/19  08:35:09  jpo
 * General clean up - plus sun specific fixes
 * 
 * Revision 1.3  87/10/16  17:09:10  jpo
 * Purged the ad-hoc routing stuff. Added select too.
 * 
 * Revision 1.2  87/10/04  18:30:05  jpo
 * Added select & r/w
 * 
 */

#ifndef _NET_IF_TNREG_H_
#define _NET_IF_TNREG_H_

#include <netinet/in_systm.h>

/*
 * control structure
 */
struct tun_softc
{
	u_short		tun_flags;	/* misc flags */
#define TUN_INITED      0x001	/* device has been initialised */
#define TUN_RWAIT       0x002	/* waiting for a read from the i/f */
#define TUN_OPEN        0x004	/* device is open */
#define TUN_IASET	0x008	/* interface address set */
#define	TUN_DSTADDR	0x010	/* destination address set */
#define TUN_READY	(TUN_IASET|TUN_OPEN|TUN_DSTADDR)
				/* device ready for use */
#define TUN_WCOLL	0x020	/* select write collision (not supported) */
#define TUN_RCOLL	0x040	/* select collision on read */
#define TUN_NBIO	0x080	/* non block I/O state */
#define TUN_ASYNC	0x100	/* async I/O state */
#define TUN_BOUNCE	0x200	/* if we are bouncing packets */

	struct ifnet	tun_if;		/* the interface */
	int		tun_pgrp;	/* the process group - if any */
	struct proc    *tun_rsel;	/* read select */
	struct proc    *tun_wsel;	/* write select (not used) */
	struct ifqueue  if_fastq;	/* queue for interactive traffic */
	n_time		if_lastq;	/* time of last source quench */
};

/*
 * defines for the Tunnel pseudo driver.
 */

#define TUNMTU		1500	/* default maximum size packet sent to iface */
#define TUNDQUENCH	100	/* time between two source quenches (ms) */

/*
 * ioctl calls for the special device.
 */
#define TUNSDEBUG       _IOW(u, 0, int) /* set debugging level on/off */
#define TUNGDEBUG	_IOR(u, 1, int) /* read debugging level */
#define TUNIFBOUNCE	_IOW(u, 2, int) /* bounce packets sent to tun if. */
#define	TUNSIFINFO	_IOW(u, 3, struct tuninfo)
#define	TUNGIFINFO	_IOR(u, 4, struct tuninfo)

struct tuninfo {
	int	if_baudrate;		/* linespeed */
	short	if_mtu;			/* maximum transmission unit */
	u_char	if_type;		/* ethernet, tokenring, etc. */
	u_char	if_dummy;		/* place holder */
};

#endif /* !_NET_IF_TNREG_H_ */
